



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>如何使用纯CSS制作特效导航条？</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">如何使用纯CSS制作特效导航条？</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 07:53:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>先上张图，如何使用纯 CSS 制作如下效果？</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1160527/201804/1160527-20180406162220372-623050296.gif" /></p>
<p>在继续阅读下文之前，你可以先缓一缓。尝试思考一下上面的效果或者动手尝试一下，不借助 JS ，能否巧妙的实现上述效果。</p>
<p>OK，继续。这个效果是我在业务开发的过程中遇到的一个类似的小问题。其实即便让我借助 Javascript ，我的第一反应也是，感觉很麻烦啊。所以我一直在想，有没有可能只使用 CSS 完成这个效果呢？</p>
<h2>定义需求</h2>
<p>我们定义一下简单的规则，要求如下：</p>
<div>
<pre class="prettyprint linenums">&lt;ul&gt;<br />
  &lt;li&gt;不可思议的CSS&lt;/li&gt;<br />
  &lt;li&gt;导航栏&lt;/li&gt;<br />
  &lt;li&gt;光标小下划线跟随&lt;/li&gt;<br />
  &lt;li&gt;PURE CSS&lt;/li&gt;<br />
  &lt;li&gt;Nav Underline&lt;/li&gt;<br />
&lt;/ul&gt;</pre>
</div>
<ul><li><p>导航栏目的 li 的宽度是不固定的</p></li>
<li><p>当从导航的左侧 li 移向右侧 li，下划线从左往右移动。同理，当从导航的右侧 li 移向左侧 li，下划线从右往左移动。</p></li></ul>
<h2>实现需求</h2>
<p>第一眼看到这个效果，感觉这个跟随动画，仅靠 CSS 是不可能完成的。 如果想只用 CSS 实现，只能另辟蹊径，使用一些讨巧的方法。 好，下面就借助一些奇技淫巧，使用 CSS 一步一步完成这个效果。分析一下难点：</p>
<h3>宽度不固定</h3>
<p>第一个难点， li 的宽度是不固定的。所以，我们可能需要从 li 本身的宽度上做文章。 既然每个 li 的宽度不一定，那么它对应的下划线的长度，肯定是是要和他本身相适应的。自然而然，我们就会想到使用它的 border-bottom 。</p>
<div>
<pre class="prettyprint linenums">li { border-bottom: 2px solid #;}</pre>
</div>
<p>那么，可能现在是这样子的（li 之间是相连在一起的，li 间的间隙使用 padding 产生）：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1160527/201804/1160527-20180406162539315-431266102.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQImWNgYGBgAAAABQABh6FO1AAAAABJRU5ErkJggg==" data-src="https://mmbiz.qpic.cn/mmbiz_png/MpGQUHiaib4ib7V4u1u5ibuicuAc027l1bumduzZq9ugvpIzN5ia3t2o3gKxe4ngia7XXGTx9Cfdmww59MDQpJnXnAFYA/640?wx_fmt=png" /></p>
<p>当然，这里一开始都是没有下划线的，所以我们可能需要把他们给隐藏起来。</p>
<div>
<pre class="prettyprint linenums">li { border-bottom: 0px solid #;}</pre>
</div>
<h3>推翻重来，借助伪元素</h3>
<p>这样好像不行，因为隐藏之后，hover li 的时候，需要下划线动画，而 li 本身肯定是不能移动的。所以，我们考虑借助伪元素。将下划线作用到每个 li 的伪元素之上。</p>
<div>
<pre class="prettyprint linenums">li::before {<br />
  content: "";<br />
  position: absolute;<br />
  top: ;<br />
  left: ;<br />
  width: %;<br />
  height: %;<br />
  border-bottom: 2px solid #;<br />
}</pre>
</div>
<p>下面考虑第一步的动画，hover 的时候，下划线要从一侧运动展开。所以，我们利用绝对定位，将 li 的伪元素的宽度设置为0，在 hover 的时候，宽度从 width: 0 -&gt; width: 100%，CSS 如下：</p>
<div>
<pre class="prettyprint linenums">li::before {<br />
  content: "";<br />
  position: absolute;<br />
  top: ;<br />
  left: ;<br />
  width: ;<br />
  height: %;<br />
  border-bottom: 2px solid #;<br />
}<br />
li:hover::before {<br />
    width: %;<br />
}</pre>
</div>
<p>得到，如下效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1160527/201804/1160527-20180406162623972-958300547.gif" /></p>
<h2>左移左出，右移右出</h2>
<p>OK，感觉离成功近了一步。现在还剩下一个最难的问题：</p>
<p>如何让线条跟随光标的移动动作，实现当从导航的左侧 li 移向右侧 li，下划线从左往右移动。同理，当从导航的右侧 li 移向左侧 li，下划线从右往左移动。</p>
<p>我们仔细看看，现在的效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1160527/201804/1160527-20180406162715036-476032450.gif" /></p>
<p>当从第一个 li 切换到第二个 li 的时候，第一个 li 下划线收回的方向不正确。所以，可以能我们需要将下划线的初始位置位移一下，设置为 left: 100%，这样每次下划线收回的时候，第一个 li 就正确了：</p>
<div>
<pre class="prettyprint linenums">li::before {<br />
  content: "";<br />
  position: absolute;<br />
  top: ;<br />
  left: %;<br />
  width: ;<br />
  height: %;<br />
  border-bottom: 2px solid #;<br />
}<br />
li:hover::before {<br />
  left: ;<br />
  width: %;<br />
}</pre>
</div>
<p>看看效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1160527/201804/1160527-20180406162852052-1308196146.gif" /></p>
<p>额，仔细对比两张图，第二种效果其实是捡了芝麻丢了西瓜。第一个 li 的方向是正确了，但是第二个 li 下划线的移动方向又错误了。</p>
<h2>神奇的 ~ 选择符</h2>
<p>所以，我们迫切需要一种方法，能够不改变当前 hover 的 li 的下划线移动方式却能改变它下一个 li 的下划线的移动方式（好绕口）。</p>
<p><strong>没错了，这里我们可以借助 ~ 选择符，完成这个艰难的使命，也是这个例子中，最最重要的一环。</strong></p>
<p>对于当前 hover 的 li ，其对应伪元素的下划线的定位是 left: 100%，而对于 li:hover ~ li::before，它们的定位是 left: 0。CSS 代码大致如下：</p>
<div>
<pre class="prettyprint linenums">li::before {<br />
  content: "";<br />
  position: absolute;<br />
  top: ;<br />
  left: %;<br />
  width: ;<br />
  height: %;<br />
  border-bottom: 2px solid #;<br />
  transition: .2s all linear;<br />
}<br />
li:hover::before {<br />
  width: %;<br />
  left: ;<br />
}<br />
li:hover ~ li::before {<br />
  left: ;<br />
}</pre>
</div>
<p>至此，我们想要的效果就实现拉！撒花。看看：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1160527/201804/1160527-20180406163021435-1872333748.gif" /></p>
<p>效果不错，就是有点僵硬，我们可以<strong>适当改变缓动函数</strong>以及加上一个<strong>动画延迟</strong>，就可以实现上述开头里的那个效果了。当然，这些都是锦上添花的点缀。（以上非原创，转自网络）</p>
<p>完整代码实例如下：</p>
<div>
<pre class="prettyprint linenums"> &lt;!DOCTYPE html&gt;<br />
 &lt;html&gt;<br />
     &lt;head&gt;<br />
         &lt;meta charset="UTF-8"&gt;<br />
         &lt;title&gt;&lt;/title&gt;<br />
     &lt;/head&gt;<br />
     &lt;style&gt;<br />
         *{margin:;padding:;}<br />
         a{text-decoration:none;color:#;}<br />
         ul{margin-top:100px;}<br />
         li{float:left;list-style:none;padding: 20px;cursor:pointer;position:relative;}<br />
         li::before {<br />
           content: "";<br />
           position: absolute;<br />
           top: ;<br />
           left: %;<br />
           width: ;<br />
           height: %;<br />
           border-bottom: 2px solid #4C7C9C;<br />
           transition: .2s all linear;<br />
           z-index:-;<br />
         }<br />
         li:hover::before {<br />
           width: %;<br />
           left: ;<br />
         }<br />
         li:hover ~ li::before {<br />
           left: ;<br />
         }<br />
     &lt;/style&gt;<br />
     &lt;body&gt;<br />
         &lt;ul&gt;<br />
             &lt;li&gt;&lt;a href="http://www.baidu.com"&gt;&lt;/a&gt;&lt;/li&gt;<br />
             &lt;li&gt;&lt;a href="http://www.taobao.com"&gt;&lt;/a&gt;&lt;/li&gt;<br />
             &lt;li&gt;&lt;a href="http://www.sina.com"&gt;&lt;/a&gt;&lt;/li&gt;<br />
             &lt;li&gt;&lt;a href="http://www.jd.com"&gt;&lt;/a&gt;&lt;/li&gt;<br />
             &lt;li&gt;&lt;a href="http://www.360.com"&gt;&lt;/a&gt;&lt;/li&gt;<br />
         &lt;/ul&gt;<br />
     &lt;/body&gt;<br />
 &lt;/html&gt;</pre>
</div>
<p>实际项目中若li里面有a标签出现不能点击的情况，注意检查伪类和li的层级关系，设置好各自z-index值</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39023ljq.html">&lbrack;CareerCup&rsqb; 1&period;1 Unique Characters of a String 字符串中不同的字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zl1p3q.html">【代码笔记】iOS-提醒时间的选择</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k46lr9.html">android toast几种使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn3l3j9.html">C&plus;&plus; friend</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ox24x8.html">This system is not registered with RHN</a>
		</li>
						<li><a href="https://www.batexi.com/a/m966vv49.html">Fluentd 例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yz050q.html">Linux驱动设计&mdash;&mdash;字符设备驱动（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y6wpeq.html">UIButton 未响应原因分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zoyo49.html">PS之火焰铁锈字</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1zejd9.html">get client machine name</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mr0rgq.html">NPM与调试工具的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnx569.html">mysql配置主从数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyx3zm9.html">【java设计模式】【行为模式Behavioral Pattern】迭代器模式Iterator Pattern</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlljjleq.html">JDK源码中，都有哪些NB的设计模式？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdd4zz9.html">python高级-异常&lpar;13&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25574oq.html">Verification and validation</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjd1we9.html">在VC中改变TAB顺序的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv67yx8.html">el表达式字符串与变量拼接</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdgdye9.html">NUC972---Linux驱动开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppdd2z9.html">oracle 树型结构数据的查询</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90m66d48.html">有关promise的技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1zzljq.html">将本地jar包打包到本地仓库和上传到私服</a>
			</li>
						<li><a href="https://www.batexi.com/a/9504rpz8.html">&lbrack;Swift&rsqb;LeetCode286&period; 墙和门 &dollar; Walls and Gates</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd0jwy9.html">&lbrack;Swift&rsqb;LeetCode940&period; 不同的子序列 II &vert; Distinct Subsequences II</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyn1rk9.html">多线程系列（四）：Task</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eynype9.html">SpringMVC&plus;JWT&plus;Swagger UI&plus;RestFul</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z6ok19.html">vue &plus; hbuilder 开发备忘录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me3l5oq.html">大数据技术之&lowbar;19&lowbar;Spark学习&lowbar;01&lowbar;Spark 基础解析 &plus; Spark 概述 &plus; Spark 集群安装 &plus; 执行 Spark 程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj153z8.html">Chapter 5 Blood Type&mdash;&mdash;10</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mzero8.html">精读《React PowerPlug 源码》</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
